/* Problem URL: https://codeforces.com/edu/course/2/lesson/2/4/practice/contest/269119/problem/A */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 0

void solve()
{
    string a;
    cin >> a;
    a.push_back('$');
    int n = a.size();

    vi suf(n);
    vi cnt(max(256, n));
    vi pos(n);

    rep(i, n) {
        cnt[a[i]]++;
    }

    nrep(i, 1, cnt.size()) {
        cnt[i] += cnt[i - 1];
    }

    rep(i, n) {
        cnt[a[i]]--;
        pos[cnt[a[i]]] = i;
    }

    nrep(i, 1, n) {
        suf[pos[i]] = suf[pos[i - 1]];
        if (a[pos[i]] != a[pos[i - 1]]) {
            suf[pos[i]]++;
        }
    }

    vi tsuf(n);
    vi tpos(n);
    for (int j = 0; (1 << j) < n; j++) {
        rep(i, n) {
            tpos[i] = pos[i] - (1 << j);
            tpos[i] += n * (tpos[i] < 0);
        }

        fill(all(cnt), 0);

        rep(i, n) {
            cnt[suf[tpos[i]]]++;
        }

        nrep(i, 1, cnt.size()) {
            cnt[i] += cnt[i - 1];
        }

        for (int i = n - 1; i >= 0; i--) {
            cnt[suf[tpos[i]]]--;
            pos[cnt[suf[tpos[i]]]] = tpos[i];
        }

        tsuf[pos[0]] = 0;
        nrep(i, 1, n) {
            pair<int, int> cur = {suf[pos[i]], suf[(pos[i] + (1 << j)) % n]};
            pair<int, int> prev = {suf[pos[i - 1]], suf[(pos[i - 1] + (1 << j)) % n]};

            tsuf[pos[i]] = tsuf[pos[i - 1]];
            if (cur != prev) {
                tsuf[pos[i]]++;
            }
        }

        swap(tsuf, suf);
    }

    vi inv(n);
    rep(i, n) {
        inv[pos[i]] = i;
    }

    vi lcp(n - 1);
    vi skip(n + 1);
    rep(i, n - 1) {
        int j = inv[i];
        if (j == n - 1) {
            continue;
        }
        j = pos[j + 1];

        int k = skip[i];
        while (a[i + k] == a[j + k]) {
            k++;
        }

        lcp[inv[i]] = k;
        skip[i + 1] = max(0, k - 1);
    }

    cout << pos;
    cout << lcp;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
